diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/product_editor.cpp lmi-editor/product_editor.cpp
--- cvs/product_editor.cpp	2008-01-10 18:31:47.000000000 +0100
+++ lmi-editor/product_editor.cpp	2008-02-08 14:57:58.000000000 +0100
@@ -50,10 +50,14 @@
 bool ProductEditorDocument::IsModified() const
 {
     if(wxDocument::IsModified())
-        {return true;}
+        {
+        return true;
+        }
 
     if(GetViews().empty())
-        {return false;}
+        {
+        return false;
+        }
 
     return PredominantView().IsModified();
 }
@@ -62,25 +66,53 @@
 {
     wxDocument::Modify(modified);
     if(!modified && !GetViews().empty())
-        {PredominantView().DiscardEdits();}
-}
-
-bool ProductEditorDocument::OnOpenDocument(wxString const& filename)
-{
-    ReadDocument(std::string(filename));
-
-    SetFilename(filename, true);
-    Modify(false);
-    UpdateAllViews();
-    return true;
-}
-
-bool ProductEditorDocument::OnSaveDocument(wxString const& filename)
-{
-    WriteDocument(std::string(filename));
-
-    Modify(false);
-    return true;
+        {
+        PredominantView().DiscardEdits();
+        }
+}
+
+bool ProductEditorDocument::DoOpenDocument(wxString const& filename)
+{
+    try
+        {
+        ReadDocument(std::string(filename));
+        return true;
+        }
+    catch(std::exception const& e)
+        {
+        warning()
+            << "Error while loading document.\n"
+            << "Filename: "
+            << filename
+            << "\n"
+            << "Message: "
+            << e.what()
+            << LMI_FLUSH
+            ;
+        return false;
+        }
+}
+
+bool ProductEditorDocument::DoSaveDocument(wxString const& filename)
+{
+    try
+        {
+        WriteDocument(std::string(filename));
+        return true;
+        }
+    catch(std::exception const& e)
+        {
+        warning()
+            << "Error while saving document.\n"
+            << "Filename: "
+            << filename
+            << "\n"
+            << "Message: "
+            << e.what()
+            << LMI_FLUSH
+            ;
+        return false;
+        }
 }
 
 ProductEditorView::ProductEditorView()
@@ -94,6 +126,9 @@
 
 TreeGridViewBase::TreeGridViewBase()
     :ProductEditorView()
+    ,grid_(NULL)
+    ,grid_label_(NULL)
+    ,tree_(NULL)
 {
 }
 
@@ -101,6 +136,42 @@
 {
 }
 
+wxTreeCtrl& TreeGridViewBase::tree() const
+{
+    if(!tree_)
+        {
+        fatal_error()
+            << "Tree control can't be null"
+            << LMI_FLUSH
+            ;
+        }
+    return *tree_;
+}
+
+MultiDimGrid& TreeGridViewBase::grid() const
+{
+    if(!grid_)
+        {
+        fatal_error()
+            << "Grid control can't be null"
+            << LMI_FLUSH
+            ;
+        }
+    return *grid_;
+}
+
+void TreeGridViewBase::set_grid_label_text(std::string const& label)
+{
+    if(!grid_label_)
+        {
+        fatal_error()
+            << "Grid control can't be null"
+            << LMI_FLUSH
+            ;
+        }
+    grid_label_->SetLabel(label);
+}
+
 wxWindow* TreeGridViewBase::CreateChildWindow()
 {
     wxPanel* main_panel = new(wx) wxPanel(GetFrame());
@@ -110,19 +181,30 @@
 
     grid_label_ = new(wx) wxStaticText(main_panel, wxID_ANY, "");
 
-    // Title text bold and 1.5 bigger
+    // Make label text is bold.
     wxFont font = main_panel->GetFont();
     font.SetWeight(wxFONTWEIGHT_BOLD);
-    font.SetPointSize(font.GetPointSize() * 3 / 2);
     grid_label_->SetFont(font);
 
-    wxBoxSizer* sizer = new(wx) wxBoxSizer(wxHORIZONTAL);
-    wxBoxSizer* grid_sizer = new(wx) wxBoxSizer(wxVERTICAL);
+    wxBoxSizer* const sizer = new(wx) wxBoxSizer(wxHORIZONTAL);
+    wxBoxSizer* const grid_sizer = new(wx) wxBoxSizer(wxVERTICAL);
 
-    sizer->Add(tree_, wxSizerFlags().Proportion(0).Expand());
-    sizer->Add(grid_sizer, wxSizerFlags().Proportion(1).Expand());
-    grid_sizer->Add(grid_label_, wxSizerFlags().Proportion(0).Expand().Border(wxALL, 8));
-    grid_sizer->Add(grid_, wxSizerFlags().Proportion(1).Expand());
+    sizer->Add
+        (tree_
+        ,wxSizerFlags().Proportion(0).Expand()
+        );
+    sizer->Add
+        (grid_sizer
+        ,wxSizerFlags().Proportion(1).Expand()
+        );
+    grid_sizer->Add
+        (grid_label_
+        ,wxSizerFlags().Proportion(0).Expand().Border(wxALL, 8)
+        );
+    grid_sizer->Add
+        (grid_
+        ,wxSizerFlags().Proportion(1).Expand()
+        );
 
     main_panel->SetSizer(sizer);
 
@@ -130,11 +212,9 @@
 
     main_panel->SetSize(GetFrame()->GetClientSize());
 
-    return main_panel;
-}
+    // Hide the grid until a node in the tree is selected
+    grid_sizer->Hide(grid_);
 
-void TreeGridViewBase::SetLabel(std::string const& label)
-{
-    grid_label_->SetLabel(label);
+    return main_panel;
 }
 
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/product_editor.hpp lmi-editor/product_editor.hpp
--- cvs/product_editor.hpp	2008-01-10 18:31:47.000000000 +0100
+++ lmi-editor/product_editor.hpp	2008-01-30 21:04:28.000000000 +0100
@@ -63,8 +63,8 @@
     // wxDocument overrides.
     virtual bool IsModified() const;
     virtual void Modify(bool modified);
-    virtual bool OnOpenDocument(wxString const& filename);
-    virtual bool OnSaveDocument(wxString const& filename);
+    virtual bool DoOpenDocument(wxString const& filename);
+    virtual bool DoSaveDocument(wxString const& filename);
 };
 
 /// Common base for all product editor view classes.
@@ -96,32 +96,28 @@
     virtual ~TreeGridViewBase();
 
   protected:
-    wxTreeCtrl&   GetTreeCtrl() const;
-    MultiDimGrid& GetGridCtrl() const;
-    void SetLabel(std::string const&);
+    MultiDimGrid& grid() const;
+    wxTreeCtrl&   tree() const;
 
-    virtual wxTreeCtrl*   CreateTreeCtrl(wxWindow* parent) = 0;
+    void set_grid_label_text(std::string const&);
+
+    // Returned objects must be constructed as children of 'parent', so that
+    // the returned objects ownership is managed by wx.
     virtual MultiDimGrid* CreateGridCtrl(wxWindow* parent) = 0;
+    virtual wxTreeCtrl*   CreateTreeCtrl(wxWindow* parent) = 0;
+
     virtual void SetupControls() = 0;
 
   private:
     // ViewEx required implementation.
     virtual wxWindow* CreateChildWindow();
 
-    wxTreeCtrl*   tree_;
+    // These objects are held by pointer since the destruction is taken care
+    // of by wx.
     MultiDimGrid* grid_;
     wxStaticText* grid_label_;
+    wxTreeCtrl*   tree_;
 };
 
-inline wxTreeCtrl& TreeGridViewBase::GetTreeCtrl() const
-{
-    return *tree_;
-}
-
-inline MultiDimGrid& TreeGridViewBase::GetGridCtrl() const
-{
-    return *grid_;
-}
-
 #endif // product_editor_hpp
 
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/rounding_view_downward_hover.xpm lmi-editor/rounding_view_downward_hover.xpm
--- cvs/rounding_view_downward_hover.xpm	1970-01-01 01:00:00.000000000 +0100
+++ lmi-editor/rounding_view_downward_hover.xpm	2008-02-08 15:12:05.000000000 +0100
@@ -0,0 +1,79 @@
+/* XPM */
+static char const* rounding_view_downward_hover_xpm[] = {
+"16 16 60 1",
+" 	c None",
+"!	c #82BB91",
+"#	c #D1F6DF",
+"$	c #C3E6D0",
+"%	c #29302C",
+"&	c #1A1F1C",
+"'	c #B9D8C6",
+"(	c #A3BFAE",
+")	c black",
+"*	c #4F5C54",
+"+	c #C8E9D6",
+",	c #CEF3DD",
+"-	c #ADCBBA",
+".	c #0C0E0D",
+"0	c #3A4340",
+"1	c #191D1B",
+"2	c #252A28",
+"3	c #AEC6BE",
+"4	c #BBD8CA",
+"5	c #CCEFDA",
+"6	c #7C8F87",
+"7	c #0B0C0C",
+"8	c #8C9E9B",
+"9	c #ABC2BB",
+":	c #C0DFCF",
+";	c #97B2A2",
+"<	c #9EB8AA",
+"=	c #778981",
+">	c #82928F",
+"?	c #798885",
+"@	c #879B92",
+"A	c #C9EBD7",
+"B	c #D0F5DE",
+"C	c #515F57",
+"D	c #0D0F0E",
+"E	c #92A79E",
+"F	c #6B7A74",
+"G	c #6E7F77",
+"H	c #C2E1D1",
+"I	c #CDF1DB",
+"J	c #BDDCCA",
+"K	c #222725",
+"L	c #0C0D0D",
+"M	c #454F4C",
+"N	c #ABC3BC",
+"O	c #BBD9CB",
+"P	c #CCF0DB",
+"Q	c #CEF2DC",
+"R	c #99B1A5",
+"S	c #0B0D0C",
+"T	c #202423",
+"U	c #96A9A6",
+"V	c #AEC7BE",
+"W	c #C4E4D2",
+"X	c #D0F4DE",
+"Y	c #CBEEDA",
+"Z	c #A1BAAF",
+"[	c #9EB2AD",
+"]	c #BFDECE",
+"^	c #CAEDD9",
+"!!!!!!!!!!!!!!!!",
+"!##############!",
+"!##############!",
+"!##############!",
+"!##############!",
+"!###$%&'()*+,##!",
+"!####-.012345##!",
+"!####56)789:,##!",
+"!###$;<=>?@AB##!",
+"!####CDEF)GHI##!",
+"!####J2KLMNOP##!",
+"!####QRSTUVWX##!",
+"!#####YZ[N]Q###!",
+"!#####B^HWP####!",
+"!#######XB#####!",
+"!!!!!!!!!!!!!!!!"};
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/rounding_view_downward_selected.xpm lmi-editor/rounding_view_downward_selected.xpm
--- cvs/rounding_view_downward_selected.xpm	1970-01-01 01:00:00.000000000 +0100
+++ lmi-editor/rounding_view_downward_selected.xpm	2008-02-08 15:12:05.000000000 +0100
@@ -0,0 +1,77 @@
+/* XPM */
+static char const* rounding_view_downward_selected_xpm[] = {
+"16 16 58 1",
+" 	c None",
+"!	c #003C74",
+"#	c #A1BEED",
+"$	c #96B1DD",
+"%	c #20252F",
+"&	c #15181E",
+"'	c #92AAD2",
+"(	c #7F95B9",
+")	c black",
+"*	c #3E485A",
+"+	c #9DB7E3",
+",	c #A0BCEA",
+"-	c #889FC5",
+".	c #0A0B0E",
+"0	c #303743",
+"1	c #14171C",
+"2	c #1E222A",
+"3	c #90A4C7",
+"4	c #96ADD4",
+"5	c #9FBAE7",
+"6	c #64738D",
+"7	c #090A0C",
+"8	c #7886A1",
+"9	c #8FA1C3",
+":	c #99B1DA",
+";	c #758AAC",
+"<	c #7C91B3",
+"=	c #626F88",
+">	c #6F7C95",
+"?	c #67738B",
+"@	c #6D7D99",
+"A	c #9DB8E4",
+"B	c #A0BDEC",
+"C	c #3F4A5C",
+"D	c #0A0C0F",
+"E	c #7687A6",
+"F	c #58647A",
+"G	c #59677D",
+"H	c #9AB3DC",
+"I	c #9FBBE9",
+"J	c #93ADD6",
+"K	c #1D2027",
+"L	c #0A0B0D",
+"M	c #3A414F",
+"N	c #8FA2C4",
+"O	c #97AED5",
+"P	c #9FBAE8",
+"Q	c #9FBCE9",
+"R	c #7A8DAE",
+"S	c #1C1F25",
+"T	c #8190AC",
+"U	c #9BB4DE",
+"V	c #A0BDEB",
+"W	c #9EBAE7",
+"X	c #8296B8",
+"Y	c #8595B4",
+"Z	c #A1BDEC",
+"[	c #9EB9E5",
+"!!!!!!!!!!!!!!!!",
+"!##############!",
+"!##############!",
+"!##############!",
+"!##############!",
+"!###$%&'()*+,##!",
+"!####-.012345##!",
+"!####56)789:,##!",
+"!###$;<=>?@AB##!",
+"!####CDEF)GHI##!",
+"!####J2KLMNOP##!",
+"!####QRLST3UV##!",
+"!#####WXYN:Q###!",
+"!#####Z[HUP####!",
+"!#######VB#####!",
+"!!!!!!!!!!!!!!!!"};
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/rounding_view_downward.xpm lmi-editor/rounding_view_downward.xpm
--- cvs/rounding_view_downward.xpm	1970-01-01 01:00:00.000000000 +0100
+++ lmi-editor/rounding_view_downward.xpm	2008-02-08 15:12:05.000000000 +0100
@@ -0,0 +1,77 @@
+/* XPM */
+static char const* rounding_view_downward_xpm[] = {
+"16 16 58 1",
+" 	c None",
+"!	c #ECE9D8",
+"#	c #DCD9CA",
+"$	c #2E2E2B",
+"%	c #1E1D1C",
+"&	c #CFCCC0",
+"'	c #B7B6AA",
+"(	c black",
+")	c #585752",
+"*	c #E0DED0",
+"+	c #E9E6D6",
+",	c #C3C0B4",
+"-	c #0D0D0D",
+".	c #40403E",
+"0	c #1B1B1A",
+"1	c #282827",
+"2	c #BFBEBA",
+"3	c #CFCEC5",
+"4	c #E5E3D4",
+"5	c #8A8983",
+"6	c #0C0C0C",
+"7	c #989998",
+"8	c #BBBAB7",
+"9	c #D6D4C9",
+":	c #ABA99D",
+";	c #B1AFA5",
+"<	c #83837F",
+"=	c #8D8E8D",
+">	c #838383",
+"?	c #95948E",
+"@	c #E2DFD1",
+"A	c #EBE8D7",
+"B	c #5C5A54",
+"C	c #0E0E0D",
+"D	c #A1A09A",
+"E	c #767671",
+"F	c #797974",
+"G	c #D8D7CB",
+"H	c #E7E4D5",
+"I	c #D4D1C4",
+"J	c #252525",
+"K	c #0D0D0C",
+"L	c #4C4C4A",
+"M	c #BBBBB7",
+"N	c #D0CFC5",
+"O	c #E6E3D4",
+"P	c #E8E5D5",
+"Q	c #AAA9A0",
+"R	c #232323",
+"S	c #A2A3A2",
+"T	c #BFBFBA",
+"U	c #DBD9CC",
+"V	c #EAE7D7",
+"W	c #E5E2D3",
+"X	c #B3B2AA",
+"Y	c #ACACA9",
+"Z	c #D5D3C9",
+"[	c #E3E1D2",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!#$%&'()*+!!!",
+"!!!!!,-.01234!!!",
+"!!!!!45(6789+!!!",
+"!!!!#:;<=>?@A!!!",
+"!!!!!BCDE(FGH!!!",
+"!!!!!I1JKLMNO!!!",
+"!!!!!PQ6RSTUV!!!",
+"!!!!!!WXYMZP!!!!",
+"!!!!!!A[GUO!!!!!",
+"!!!!!!!!VA!!!!!!",
+"!!!!!!!!!!!!!!!!"};
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/rounding_view_editor.cpp lmi-editor/rounding_view_editor.cpp
--- cvs/rounding_view_editor.cpp	2008-02-07 18:25:39.000000000 +0100
+++ lmi-editor/rounding_view_editor.cpp	2008-02-08 14:59:15.000000000 +0100
@@ -23,14 +23,21 @@
 
 #include "rounding_view_editor.hpp"
 
+#include "alert.hpp"
 #include "wx_new.hpp"
 
+#include <wx/bitmap.h>
+#include <wx/bmpbuttn.h>
 #include <wx/dcclient.h> // class wxClientDC
 #include <wx/sizer.h>
 #include <wx/spinctrl.h>
 #include <wx/tglbtn.h>
 #include <wx/window.h>
 
+#include <map>
+#include <sstream>
+#include <utility>
+
 namespace
 {
 
@@ -41,18 +48,112 @@
     ,e_rbi_downward
     };
 
+// toggle button states we are interested in
+enum enum_bitmap_button_state
+    {e_state_normal
+    ,e_state_hover
+    ,e_state_selected
+    };
+
+// bitmap storage
+typedef std::map
+    <std::pair<rounding_style,enum_bitmap_button_state>
+    ,wxBitmap
+    > button_bitmaps;
+
+// Returns the bitmap storage. Loads resources when called for the first time.
+button_bitmaps const& all_button_bitmaps()
+{
+    static button_bitmaps bitmaps;
+
+    if(bitmaps.empty())
+        {
+        typedef std::map<rounding_style, std::string> style_names;
+        style_names styles;
+        styles[r_not_at_all] = "not_at_all";
+        styles[r_to_nearest] = "to_nearest";
+        styles[r_upward]     = "upward";
+        styles[r_downward]   = "downward";
+
+        typedef std::map<enum_bitmap_button_state, std::string> state_names;
+        state_names states;
+        states[e_state_normal]   = "";
+        states[e_state_hover]    = "_hover";
+        states[e_state_selected] = "_selected";
+
+        wxXmlResource& xml_resources = *wxXmlResource::Get();
+        for
+            (style_names::const_iterator li = styles.begin()
+            ;li != styles.end()
+            ;++li
+            )
+            {
+            for
+                (state_names::const_iterator ti = states.begin()
+                ;ti != states.end()
+                ;++ti
+                )
+                {
+                std::ostringstream oss;
+                oss
+                    << "rounding_view_"
+                    << li->second
+                    << ti->second
+                    ;
+                bitmaps[std::make_pair(li->first, ti->first)] =
+                    xml_resources.LoadBitmap(oss.str());
+                }
+            }
+        }
+    return bitmaps;
+}
+
+// return the bitmap corrsponding to the 'button' in the 'state'
+wxBitmap const& get_button_bitmap
+    (rounding_style button
+    ,enum_bitmap_button_state state
+    )
+{
+    button_bitmaps const& bitmaps = all_button_bitmaps();
+    button_bitmaps::const_iterator it =
+        bitmaps.find(std::make_pair(button, state));
+    if(it == bitmaps.end())
+        {
+        fatal_error() << "Unknown or missing button bitmap" << LMI_FLUSH;
+        }
+    return it->second;
+}
+
+void style_button(wxBitmapButton& button, rounding_style style, bool selected)
+{
+    button.SetBitmapLabel(get_button_bitmap(style, selected
+        ? e_state_selected
+        : e_state_normal
+        ));
+
+    button.SetBitmapSelected(get_button_bitmap(style, selected
+        ? e_state_selected
+        : e_state_hover
+        ));
+
+    button.SetBitmapHover(get_button_bitmap(style, selected
+        ? e_state_selected
+        : e_state_hover
+        ));
+}
+
 } // unnamed namespace
 
 BEGIN_EVENT_TABLE(RoundingButtons, wxPanel)
-    EVT_TOGGLEBUTTON(e_rbi_not_at_all, RoundingButtons::UponButtonClick)
-    EVT_TOGGLEBUTTON(e_rbi_to_nearest, RoundingButtons::UponButtonClick)
-    EVT_TOGGLEBUTTON(e_rbi_upward    , RoundingButtons::UponButtonClick)
-    EVT_TOGGLEBUTTON(e_rbi_downward  , RoundingButtons::UponButtonClick)
+    EVT_BUTTON(e_rbi_not_at_all, RoundingButtons::UponButtonClick)
+    EVT_BUTTON(e_rbi_to_nearest, RoundingButtons::UponButtonClick)
+    EVT_BUTTON(e_rbi_upward    , RoundingButtons::UponButtonClick)
+    EVT_BUTTON(e_rbi_downward  , RoundingButtons::UponButtonClick)
 END_EVENT_TABLE()
 
 RoundingButtons::RoundingButtons()
     :wxPanel()
-    ,original_rule_(0, r_not_at_all)
+    ,previous_value_(0, r_not_at_all)
 {
 }
 
@@ -65,7 +166,7 @@
     ,const std::string& name
     )
     :wxPanel()
-    ,original_rule_(0, r_not_at_all)
+    ,previous_value_(0, r_not_at_all)
 {
     Create(parent, id, pos, size, style, name);
 }
@@ -81,29 +182,23 @@
 {
     wxPanel::Create(parent, id, pos, size, style, name);
 
-    button_not_at_all_ = new(wx) wxToggleButton(this, e_rbi_not_at_all, "@");
-    button_to_nearest_ = new(wx) wxToggleButton(this, e_rbi_to_nearest, "x");
-    button_upward_     = new(wx) wxToggleButton(this, e_rbi_upward,     "A");
-    button_downward_   = new(wx) wxToggleButton(this, e_rbi_downward,   "V");
-    button_not_at_all_->SetToolTip("do not round at all");
-    button_to_nearest_->SetToolTip("round to nearest");
-    button_upward_    ->SetToolTip("round upward");
-    button_downward_  ->SetToolTip("round downward");
+    wxBitmap empty;
+    button_not_at_all_ = new(wx) wxBitmapButton(this, e_rbi_not_at_all, empty);
+    button_to_nearest_ = new(wx) wxBitmapButton(this, e_rbi_to_nearest, empty);
+    button_upward_     = new(wx) wxBitmapButton(this, e_rbi_upward    , empty);
+    button_downward_   = new(wx) wxBitmapButton(this, e_rbi_downward  , empty);
+
+    button_not_at_all().SetToolTip("do not round at all");
+    button_to_nearest().SetToolTip("round to nearest");
+    button_upward    ().SetToolTip("round upward");
+    button_downward  ().SetToolTip("round downward");
     spin_ = new(wx) wxSpinCtrl(this);
 
-    // adjust widgets size to be as small as possible
-    // 3 stands for the button label symbol itself plus two margins
-    wxSize button_size = CalculateMinimumTextControlSize(button_not_at_all_, 3);
-    button_size.SetHeight(button_not_at_all_->GetSize().GetHeight());
-    button_not_at_all_->SetMinSize(button_size);
-    button_to_nearest_->SetMinSize(button_size);
-    button_upward_    ->SetMinSize(button_size);
-    button_downward_  ->SetMinSize(button_size);
-
+    // adjust widget size to be as small as possible
     // 6 stands for the digit and its margins, plus the same for spin arrows
     wxSize spin_size = CalculateMinimumTextControlSize(spin_, 6);
-    spin_size.SetHeight(spin_->GetSize().GetHeight());
-    spin_->SetMinSize(spin_size);
+    spin_size.SetHeight(spin().GetSize().GetHeight());
+    spin().SetMinSize(spin_size);
 
     wxBoxSizer* sizer_ = new(wx) wxBoxSizer(wxHORIZONTAL);
     SetSizer(sizer_);
@@ -121,7 +216,7 @@
     sizer_->Add(button_upward_    , flags);
     sizer_->Add(button_downward_  , flags);
 
-    SetValue(original_rule_);
+    SetValue(previous_value_);
 }
 
 wxSize RoundingButtons::CalculateMinimumTextControlSize
@@ -147,13 +242,19 @@
 
 bool RoundingButtons::IsModified() const
 {
-    return !(GetValue() == original_rule_);
+    return !(GetValue() == previous_value_);
 }
 
 void RoundingButtons::Modify(bool modified)
 {
     if(!modified)
-        {SetValue(original_rule_);}
+        {
+        // Modify(false) is called when the document is saved, so updating last
+        // saved value here ensures that IsModified() returns whether the
+        // value changed since the last save and not since the control was
+        // created.
+        previous_value_ = GetValue();
+        }
 }
 
 void RoundingButtons::DiscardEdits()
@@ -188,7 +289,7 @@
 
 void RoundingButtons::SetValue(round_to<double> const& value)
 {
-    original_rule_ = value;
+    previous_value_ = value;
     SetNumber(value.decimals());
     SetStyle(value.style());
 }
@@ -200,38 +301,60 @@
 
 void RoundingButtons::SetNumber(int number)
 {
-    spin_->SetValue(number);
+    spin().SetValue(number);
 }
 
 int  RoundingButtons::GetNumber() const
 {
-    return spin_->GetValue();
+    return spin().GetValue();
 }
 
 void RoundingButtons::SetStyle(rounding_style const style)
 {
-    button_not_at_all_->SetValue(style == r_not_at_all);
-    button_to_nearest_->SetValue(style == r_to_nearest);
-    button_upward_    ->SetValue(style == r_upward);
-    button_downward_  ->SetValue(style == r_downward);
+    style_ = style;
+    style_button(button_not_at_all(), r_not_at_all, style == r_not_at_all);
+    style_button(button_to_nearest(), r_to_nearest, style == r_to_nearest);
+    style_button(button_upward    (), r_upward,     style == r_upward    );
+    style_button(button_downward  (), r_downward,   style == r_downward  );
 }
 
 void RoundingButtons::FixStyle(rounding_style style)
 {
     SetStyle(style);
-    button_not_at_all_->Enable(style == r_not_at_all);
-    button_to_nearest_->Enable(style == r_to_nearest);
-    button_upward_    ->Enable(style == r_upward);
-    button_downward_  ->Enable(style == r_downward);
+    button_not_at_all().Enable(style == r_not_at_all);
+    button_to_nearest().Enable(style == r_to_nearest);
+    button_upward    ().Enable(style == r_upward);
+    button_downward  ().Enable(style == r_downward);
 }
 
 rounding_style RoundingButtons::GetStyle() const
 {
-         if(button_not_at_all_->GetValue()) {return r_not_at_all;}
-    else if(button_to_nearest_->GetValue()) {return r_to_nearest;}
-    else if(button_upward_->GetValue())     {return r_upward;}
-    else if(button_downward_->GetValue())   {return r_downward;}
-    else                                    {return r_indeterminate;}
+    return style_;
+}
+
+wxSpinCtrl& RoundingButtons::spin() const
+{
+    return *spin_;
+}
+
+wxBitmapButton& RoundingButtons::button_not_at_all() const
+{
+    return *button_not_at_all_;
+}
+
+wxBitmapButton& RoundingButtons::button_to_nearest() const
+{
+    return *button_to_nearest_;
+}
+
+wxBitmapButton& RoundingButtons::button_upward() const
+{
+    return *button_upward_;
+}
+
+wxBitmapButton& RoundingButtons::button_downward() const
+{
+    return *button_downward_;
 }
 
 IMPLEMENT_DYNAMIC_CLASS(RoundingButtonsXmlHandler, wxXmlResourceHandler)
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/rounding_view_editor.hpp lmi-editor/rounding_view_editor.hpp
--- cvs/rounding_view_editor.hpp	2008-02-07 18:25:39.000000000 +0100
+++ lmi-editor/rounding_view_editor.hpp	2008-02-08 14:59:15.000000000 +0100
@@ -26,15 +26,15 @@
 
 #include "config.hpp"
 
-#include "rounding_rules.hpp"
+#include "round_to.hpp"
 
 #include <wx/panel.h>
 #include <wx/xrc/xmlres.h>
 
 #include <string>
 
+class WXDLLEXPORT wxBitmapButton;
 class WXDLLEXPORT wxSpinCtrl;
-class WXDLLEXPORT wxToggleButton;
 class WXDLLEXPORT wxWindow;
 
 class RoundingButtons
@@ -75,6 +75,12 @@
     rounding_style GetStyle() const;
     void           FixStyle(rounding_style style);
 
+    wxBitmapButton& button_not_at_all() const;
+    wxBitmapButton& button_to_nearest() const;
+    wxBitmapButton& button_upward() const;
+    wxBitmapButton& button_downward() const;
+    wxSpinCtrl& spin() const;
+
     void UponButtonClick(wxCommandEvent&);
 
     static wxSize CalculateMinimumTextControlSize
@@ -82,16 +88,15 @@
         ,unsigned int n = 1
         );
 
-// EVGENIY !! Does this class need to be Copyable or Assignable?
-// If not, then could we make 'original_rule_' a reference member?
-// Then we could probably avoid including "round_to.hpp", and just
-// use a forward declaration instead. At any rate, I think we need
-// include only "round_to.hpp", not "rounding_rules.hpp".
-    round_to<double> original_rule_;
-    wxToggleButton* button_not_at_all_;
-    wxToggleButton* button_to_nearest_;
-    wxToggleButton* button_upward_;
-    wxToggleButton* button_downward_;
+    // initial or last saved value (IsModified() returns true iff current
+    // value is different from this)
+    round_to<double> previous_value_;
+
+    rounding_style style_;
+    wxBitmapButton* button_not_at_all_;
+    wxBitmapButton* button_to_nearest_;
+    wxBitmapButton* button_upward_;
+    wxBitmapButton* button_downward_;
 
     wxSpinCtrl* spin_;
 
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/rounding_view_not_at_all_hover.xpm lmi-editor/rounding_view_not_at_all_hover.xpm
--- cvs/rounding_view_not_at_all_hover.xpm	1970-01-01 01:00:00.000000000 +0100
+++ lmi-editor/rounding_view_not_at_all_hover.xpm	2008-02-08 15:12:05.000000000 +0100
@@ -0,0 +1,51 @@
+/* XPM */
+static char const* rounding_view_not_at_all_hover_xpm[] = {
+"16 16 32 1",
+" 	c None",
+"!	c #82BB91",
+"#	c #D1F6DF",
+"$	c #B5D5C1",
+"%	c #97B2A2",
+"&	c #96B1A1",
+"'	c #96B0A1",
+"(	c #CDF1DC",
+")	c #D0F5DE",
+"*	c #6E8175",
+"+	c black",
+",	c #BDDBCC",
+"-	c #CBEDD9",
+".	c #B1CFBD",
+"0	c #8A9F95",
+"1	c #7D8F89",
+"2	c #798985",
+"3	c #B0C9C0",
+"4	c #C6E7D5",
+"5	c #B2D1BF",
+"6	c #8EA599",
+"7	c #859990",
+"8	c #83968E",
+"9	c #BAD7C9",
+":	c #C9EBD7",
+";	c #6D8175",
+"<	c #CEF2DC",
+"=	c #C4E4D3",
+">	c #B7D2C6",
+"?	c #CEF3DD",
+"@	c #CDF1DB",
+"A	c #CCF0DB",
+"!!!!!!!!!!!!!!!!",
+"!##############!",
+"!##############!",
+"!##############!",
+"!##############!",
+"!###$%&'''''()#!",
+"!###*+++++++,-#!",
+"!###.012222234#!",
+"!###567888889:#!",
+"!###;+++++++9:#!",
+"!###.012222234#!",
+"!###<=9>>>>>,-#!",
+"!####?@AAAAA()#!",
+"!##############!",
+"!##############!",
+"!!!!!!!!!!!!!!!!"};
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/rounding_view_not_at_all_selected.xpm lmi-editor/rounding_view_not_at_all_selected.xpm
--- cvs/rounding_view_not_at_all_selected.xpm	1970-01-01 01:00:00.000000000 +0100
+++ lmi-editor/rounding_view_not_at_all_selected.xpm	2008-02-08 15:12:05.000000000 +0100
@@ -0,0 +1,49 @@
+/* XPM */
+static char const* rounding_view_not_at_all_selected_xpm[] = {
+"16 16 30 1",
+" 	c None",
+"!	c #003C74",
+"#	c #A1BEED",
+"$	c #8CA5CD",
+"%	c #758AAC",
+"&	c #7589AB",
+"'	c #7588AA",
+"(	c #9FBBE9",
+")	c #A0BDEC",
+"*	c #55647C",
+"+	c black",
+",	c #98AFD7",
+"-	c #9EB9E6",
+".	c #8AA1C8",
+"0	c #6F809D",
+"1	c #69778F",
+"2	c #67738B",
+"3	c #91A5C9",
+"4	c #9CB6E1",
+"5	c #8AA2CA",
+"6	c #7183A1",
+"7	c #6D7D98",
+"8	c #6B7A95",
+"9	c #96ADD4",
+":	c #9DB8E4",
+";	c #9FBCE9",
+"<	c #9BB4DF",
+"=	c #94AAD0",
+">	c #A0BCEA",
+"?	c #9FBAE8",
+"!!!!!!!!!!!!!!!!",
+"!##############!",
+"!##############!",
+"!##############!",
+"!##############!",
+"!###$%&'''''()#!",
+"!###*+++++++,-#!",
+"!###.012222234#!",
+"!###567888889:#!",
+"!###*+++++++9:#!",
+"!###.012222234#!",
+"!###;<9=====,-#!",
+"!####>(?????()#!",
+"!##############!",
+"!##############!",
+"!!!!!!!!!!!!!!!!"};
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/rounding_view_not_at_all.xpm lmi-editor/rounding_view_not_at_all.xpm
--- cvs/rounding_view_not_at_all.xpm	1970-01-01 01:00:00.000000000 +0100
+++ lmi-editor/rounding_view_not_at_all.xpm	2008-02-08 15:12:05.000000000 +0100
@@ -0,0 +1,50 @@
+/* XPM */
+static char const* rounding_view_not_at_all_xpm[] = {
+"16 16 31 1",
+" 	c None",
+"!	c #ECE9D8",
+"#	c #CDCABB",
+"$	c #ABA99D",
+"%	c #A9A79C",
+"&	c #A9A69B",
+"'	c #E7E5D5",
+"(	c #EBE8D7",
+")	c #7C7A72",
+"*	c black",
+"+	c #D2D1C7",
+",	c #E4E1D2",
+"-	c #C6C5B8",
+".	c #999890",
+"0	c #898986",
+"1	c #848483",
+"2	c #C2C1BB",
+"3	c #DEDCCF",
+"4	c #C8C6B9",
+"5	c #9E9E95",
+"6	c #93938D",
+"7	c #908F8B",
+"8	c #CECDC4",
+"9	c #E2DFD1",
+":	c #7B7A72",
+";	c #E8E5D5",
+"<	c #DBD9CD",
+"=	c #CAC9C1",
+">	c #E9E6D6",
+"?	c #E7E4D5",
+"@	c #E6E3D4",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!#$%&&&&&'(!!",
+"!!!!)*******+,!!",
+"!!!!-.01111123!!",
+"!!!!4567777789!!",
+"!!!!:*******89!!",
+"!!!!-.01111123!!",
+"!!!!;<8=====+,!!",
+"!!!!!>?@@@@@'(!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!"};
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/rounding_view_to_nearest_hover.xpm lmi-editor/rounding_view_to_nearest_hover.xpm
--- cvs/rounding_view_to_nearest_hover.xpm	1970-01-01 01:00:00.000000000 +0100
+++ lmi-editor/rounding_view_to_nearest_hover.xpm	2008-02-08 15:12:05.000000000 +0100
@@ -0,0 +1,70 @@
+/* XPM */
+static char const* rounding_view_to_nearest_hover_xpm[] = {
+"16 16 51 1",
+" 	c None",
+"!	c #82BB91",
+"#	c #D1F6DF",
+"$	c #C3E6D0",
+"%	c #37403B",
+"&	c black",
+"'	c #343C38",
+"(	c #B9D8C7",
+")	c #CDF1DC",
+"*	c #6A7C72",
+"+	c #C9EBD7",
+",	c #CFF4DD",
+"-	c #526158",
+".	c #0D0F0E",
+"0	c #5D6A65",
+"1	c #0B0D0C",
+"2	c #232826",
+"3	c #BFDDCE",
+"4	c #B1D0BE",
+"5	c #6A7974",
+"6	c #B9D5C8",
+"7	c #CBEEDA",
+"8	c #1B1F1D",
+"9	c #47514D",
+":	c #A4B9B4",
+";	c #6F7D79",
+"<	c #39413E",
+"=	c #3F4844",
+">	c #8EA09D",
+"?	c #B4CEC3",
+"@	c #5A6663",
+"A	c #AAC2BA",
+"B	c #BBD8CA",
+"C	c #6B7C75",
+"D	c #0B0C0C",
+"E	c #626F6C",
+"F	c #A6BCB7",
+"G	c #BDDBCC",
+"H	c #CEF2DC",
+"I	c #C5E5D3",
+"J	c #B2CBC1",
+"K	c #B7D3C7",
+"L	c #C7E8D5",
+"M	c #B5D0C5",
+"N	c #A9BFB9",
+"O	c #B6D1C5",
+"P	c #C8EAD6",
+"Q	c #CDF0DB",
+"R	c #D0F4DE",
+"S	c #C9ECD8",
+"T	c #C3E3D2",
+"!!!!!!!!!!!!!!!!",
+"!##############!",
+"!##############!",
+"!##############!",
+"!##############!",
+"!##############!",
+"!###$%&'()#&*+,!",
+"!###-.01234&567!",
+"!###89:;&<=&>?7!",
+"!###&@ABCDDEFGH!",
+"!###IJK+LMNNOP#!",
+"!###QL+,RSTTSR#!",
+"!##############!",
+"!##############!",
+"!##############!",
+"!!!!!!!!!!!!!!!!"};
